//
//  Created by Lukas Hlavaty on 04.01.17.
//  Copyright (c) 2017 Lukas Hlavaty. All rights reserved.
//
#include "Statistika.h"
#include <cmath>
#include <iostream>
Statistika::Statistika()
{
    m_Analyzer = new VKostkyAnalyzer();
    m_vahy.horni= 1000;
    m_vahy.stredni= 600;
    m_vahy.ptsHorni= 90;   //5
    m_vahy.ptsStredni= 80; //4
    m_vahy.ptsDolni= 70;   //3
}

Statistika::~Statistika()
{
    //dtor
}

double Statistika::calculateBinom(int n, int k, double p)
{
    return zpoctiKombCislo(n, k)*mocnina(p, k)*mocnina((1-p), n-k);
}

double Statistika::zpoctiKombCislo(int n, int k)
{
    int komb= 1;

    if (n<0 || k>n)
        return 0;

    int i= 0;
    while (i<k)
    {
        i++;
        komb = (komb * (n-i+1))/(double)i;
    }
    return komb;
}

double Statistika::mocnina(double zaklad, int exponent)
{
    if (exponent == 0)
        return 1;

    if (exponent == 1)
        return zaklad;

    float vysledek = zaklad;
    for (int i=1; i<exponent; i++)
        vysledek = vysledek*zaklad;
    return vysledek;
}

void Statistika::generujkombinace(int pocetKostek)
{
    for (int i=0; i<6; i++)
    {
        hod[i].hodnota= 0;
        hod[i].poradi= i;
    }

    long int pocet=0; //pocet vsech kombinaci

    switch (pocetKostek)
    {
    case 1:
        hod[5].hodnota= 5;
            m_Analyzer->analyzujKombinace(hod);
            vlozZaznamDoBodyCetnost();
        hod[5].hodnota= 1;
            m_Analyzer->analyzujKombinace(hod);
            vlozZaznamDoBodyCetnost();
        pocet = 6;
        break;
    case 2:
    //kombinace dvou kostek
    {
        int kombinace=10;
        int desitky;
        desitky =1;
        while (kombinace != 66)
        {
            if ((kombinace - desitky*10) == 6)
                {
                    kombinace += 5;
                    desitky++;
                }
            else
                kombinace ++;

            pocet++;
            //std::cout<<kombinace<<std::endl;
            hod[5].hodnota= kombinace-desitky*10;   //jednotky
            hod[4].hodnota= desitky;

            //analyzuji
            bubleSort();
            m_Analyzer->analyzujKombinace(hod);
            vlozZaznamDoBodyCetnost();
        }
        //std::cout<<"pocet kombinaci: "<<pocet<<std::endl;
    }
        break;

    case 3:
    {
        pocet=0;
        int kombinace= 110;
        int stovky;
        stovky= 1;
        int desitky= 1;
        int asd =1;
        while (kombinace != 666)
        {
            if ((kombinace - stovky*100) == 66)
            {
                kombinace += 45;
                stovky++;
                desitky=1;
            }
            else
            {

                if ((kombinace -(stovky*100 +desitky*10)) == 6)
                {
                    kombinace += 5;
                    desitky++;
                }
                else
                    kombinace ++;
            }
            pocet++;
            //std::cout<<kombinace<<std::endl;
            hod[3].hodnota = kombinace/100;
            hod[4].hodnota = kombinace/10 - stovky*10;
            hod[5].hodnota = kombinace - desitky*10 - stovky*100;
            //std::cout<<hod[3].hodnota<<hod[4].hodnota<<hod[5].hodnota<<std::endl;
            //analyzuji
            bubleSort();
            m_Analyzer->analyzujKombinace(hod);
            vlozZaznamDoBodyCetnost();
        }
        //std::cout<<"pocet kombinaci: "<<pocet<<std::endl;
    }
        break;
    case 4:
    {
        pocet=0;
        int kombinace= 1110;
        int tisice= 1;
        int stovky= 1;
        int desitky= 1;
        int asd =1;
        while (kombinace != 6666)
        {
            if ((kombinace - tisice*1000) == 666)
            {
                kombinace +=445;
                tisice++;
                stovky =1;
                desitky =1;
            }
            else
            {
                if ((kombinace - stovky*100 - tisice*1000) == 66)
                {
                    kombinace += 45;
                    stovky++;
                    desitky=1;
                }
                else
                {

                    if ((kombinace -(stovky*100 +desitky*10 +tisice*1000)) == 6)
                    {
                        kombinace += 5;
                        desitky++;
                    }
                    else
                        kombinace ++;
                }
            }

            pocet++;
            //std::cout<<kombinace<<std::endl;
            hod[2].hodnota = kombinace/1000;
            hod[3].hodnota = (kombinace- tisice*1000)/100; //- desitky*10;
            hod[4].hodnota = (kombinace- tisice*1000 - stovky*100)/10; //- stovky*10;
            hod[5].hodnota = kombinace - desitky*10 - stovky*100 -tisice*1000;
            //std::cout<<hod[2].hodnota<<hod[3].hodnota<<hod[4].hodnota<<hod[5].hodnota<<std::endl;
            //analyzuji
            bubleSort();
            m_Analyzer->analyzujKombinace(hod);
            vlozZaznamDoBodyCetnost();
        }
        //std::cout<<"pocet kombinaci: "<<pocet<<std::endl;
    }
        break;
    case 5:
{
        pocet=0;
        int kombinace= 11110;
        int destisic= 1;
        int tisice= 1;
        int stovky= 1;
        int desitky= 1;
        while (kombinace != 66666)
        {
            if ((kombinace - destisic*10000) == 6666)
            {
                kombinace +=4445;
                destisic++;
                tisice= 1;
                stovky= 1;
                desitky= 1;
            }
            else
            {
                if ((kombinace - tisice*1000 - destisic*10000) == 666)
                {
                    kombinace +=445;
                    tisice++;
                    stovky =1;
                    desitky =1;
                }
                else
                {
                    if ((kombinace - stovky*100 - tisice*1000 - destisic*10000) == 66)
                    {
                        kombinace += 45;
                        stovky++;
                        desitky=1;
                    }
                    else
                    {

                        if ((kombinace -(stovky*100 +desitky*10 +tisice*1000 +destisic*10000)) == 6)
                        {
                            kombinace += 5;
                            desitky++;
                        }
                        else
                            kombinace ++;
                    }
                }
            }


            pocet++;
            hod[1].hodnota = kombinace/10000;
            hod[2].hodnota = (kombinace- destisic*10000)/1000;
            hod[3].hodnota = (kombinace- destisic*10000 - tisice*1000)/100;
            hod[4].hodnota = (kombinace- destisic*10000 - tisice*1000 - stovky*100)/10;
            hod[5].hodnota = kombinace - desitky*10 - stovky*100 -tisice*1000 -destisic*10000;
            //analyzuji
            bubleSort();
            m_Analyzer->analyzujKombinace(hod);
            vlozZaznamDoBodyCetnost();
        }


    }
        break;

    default:

        break;
    }
    m_pocetVsechKombinaci = pocet;
    //std::cout<<"pocet kombinaci: "<<m_pocetVsechKombinaci<<std::endl;
    //std::cout<<"pravdepodobnost uspechu: "<<zpoctiPtsUspechu()<<std::endl;

    for (int i=0; i<6; i++)
        hod[i].hodnota=0;
}

void Statistika::vlozZaznamDoBodyCetnost()
{
    std::vector<sKombinace> m_nalezeneKombinace = m_Analyzer->vratNalezeneKombinace();
    bool zapsano = false;
    int soucetBodu =0;
    if (m_nalezeneKombinace.size()!=0)  //pokud neni prazdna
    {
        for (int i=0; i<m_nalezeneKombinace.size(); i++)    //sectu body
        {
            if (m_nalezeneKombinace[i].body != 1500)
                soucetBodu +=m_nalezeneKombinace[i].body;
        }

        //zapisuji
        for (int j=0; j<m_bodyCetnost.size(); j++) //pokud jiz body v zaznamech existuji, navisim jen cetnost
        {
            if(m_bodyCetnost[j].body == soucetBodu)
            {
                m_bodyCetnost[j].cetnost++;
                zapsano = true;
            }
        }

        if (!zapsano)   //nenalezeno, vytvorim novy zaznam s prislusnym poctem bodu
        {
            if (soucetBodu != 0)
            {
                bodyCetnost newOne;
                newOne.body = soucetBodu;
                newOne.cetnost =1;
                m_bodyCetnost.push_back(newOne);
            }
        }
    }
}

void Statistika::vypisBodyCetnos()
{
    for (int i=0; i< m_bodyCetnost.size(); i++)
    {
        std::cout<<std::endl;
        std::cout<<"Body: "<<m_bodyCetnost[i].body<<std::endl;
        std::cout<<"Cetnost: "<<m_bodyCetnost[i].cetnost;
        std::cout<<std::endl;
    }
    std::cout<<std::endl;
}

void Statistika::vymazBodyCetnost()
{
    m_bodyCetnost.clear();
}

void Statistika::bubleSort()
{
    for (int i=0; i<6; i++)
    {
        for(int j=0; j<5; j++)
        {
            if(hod[j].hodnota>hod[j+1].hodnota){
            sKostkaPoradi pom= hod[j+1];
            hod[j+1]= hod[j];
            hod[j]= pom;
            }
        }
    }
}

double Statistika::zpoctiPtsUspechu()
{
    m_ptsUspechu = 0;
    int cetnost=0;
    for (int i=0; i<m_bodyCetnost.size(); i++)
        cetnost += m_bodyCetnost[i].cetnost;
    m_ptsUspechu = cetnost/(double)m_pocetVsechKombinaci;
    return m_ptsUspechu;
}

double Statistika::zpoctiPrumerBodu()
{
    int cetnost= 0;
    int body= 0;
    for (int i=0; i<m_bodyCetnost.size(); i++)
    {
        cetnost += m_bodyCetnost[i].cetnost;
        body += m_bodyCetnost[i].body * m_bodyCetnost[i].cetnost;
    }
    return body/(double)cetnost;
}

void Statistika::analyzujStat(int pocetPouzitychKostek, int pocetOdlozenychKostek, int docasneSkore)
{
    vymazBodyCetnost();
    int pocetVolnychKostek=6;

    //odectu drive odlozene kostky
    pocetVolnychKostek -= pocetOdlozenychKostek;

    //odectu kostky pouzite pro danou kobinaci
    pocetVolnychKostek -= pocetPouzitychKostek;

    //std::cout<<"Pocet volnych kostek: "<<pocetVolnychKostek<<std::endl;

    if(pocetVolnychKostek > 0)
    {
        generujkombinace(pocetVolnychKostek);

    }
}

double Statistika::zpoctiPtsXtice()
{

}

coHrat Statistika::vyberPostup(std::vector<sKombinace> m_nalezeneKombinace, int pocetOdlozenych, int skoreKolo)
{
    coHrat rozhodnuti;
    if (m_nalezeneKombinace.size()==0)  //nepadlo nic?
    {
            rozhodnuti.hratDal= false;
            rozhodnuti.indexKomb= -1;
            return rozhodnuti;
    }
    int soucetKostek= 0;
    for (int i=0; i<m_nalezeneKombinace.size(); i++) //kazda kombinace
    {
        soucetKostek+=m_nalezeneKombinace[i].kostkyKombinace.size();
    }
    if((soucetKostek+pocetOdlozenych)==6)   //hrat do plnych?
    {
        rozhodnuti.hratDal=true;
        rozhodnuti.indexKomb=1000;  //kod zapis vse, true hrajem do plnych
        return rozhodnuti;
    }

    int skoreCelkem= skoreKolo;
    for (int i=0; i<m_nalezeneKombinace.size(); i++)
    {
        skoreCelkem+= m_nalezeneKombinace[i].body;
    }

    //1) NEmohu zapisovat
    if (skoreCelkem < 350)
    {
        //1.1) pouze 1 kombinace?
        if (m_nalezeneKombinace.size()==1)
        {
            rozhodnuti.hratDal= true;
            rozhodnuti.indexKomb= 0;
            return rozhodnuti;
        }
        else //1.2) vice kombinaci na vyber
        {
            int bodyMax= 0;
            int indexMax= -1;
            for (int i=0; i<m_nalezeneKombinace.size(); i++)
            {
                if ((m_nalezeneKombinace[i].body>bodyMax) && (m_nalezeneKombinace[i].body!=200))
                {
                    bodyMax= m_nalezeneKombinace[i].body;
                    indexMax= i;
                }
            }
            rozhodnuti.hratDal= true;
            rozhodnuti.indexKomb= indexMax;
            return rozhodnuti;
        }
    }
    else //2) MOHU zapisovat ////////////////////////////////////////////////////////////////
    {
        //2.1 soucet horni vaha+
        if (skoreCelkem >= m_vahy.horni)
        {
            int bestIndex= 0;
            int bestSkore= 0;
            //int pocetZbyvajicichKostek;

            for (int i=0; i<m_nalezeneKombinace.size(); i++)
            {
                //pocetZbyvajicichKostek= 6 - pocetOdlozenych - m_nalezeneKombinace[i].kostkyKombinace.size();
                analyzujStat(m_nalezeneKombinace[i].kostkyKombinace.size(), pocetOdlozenych, skoreKolo);
                //generujkombinace(pocetZbyvajicichKostek);
                //std::cout<<"pts 350+ 1000+ : "<<zpoctiPtsUspechu()*100<<std::endl;
                if (m_vahy.ptsHorni < zpoctiPtsUspechu()*100)
                {
                    if ((skoreCelkem)-(skoreKolo+m_nalezeneKombinace[i].body)<=300)
                    {
                        if (m_nalezeneKombinace[i].body > bestSkore)
                        {
                            bestIndex= i;
                            bestSkore= m_nalezeneKombinace[i].body;
                        }
                    }
                }
            }

            if (bestSkore > 0)
            {
                rozhodnuti.hratDal= true;
                rozhodnuti.indexKomb= bestIndex;
                return rozhodnuti;
            }
            rozhodnuti.hratDal= false;
            rozhodnuti.indexKomb= 1000;  //kod zapis vse, false nepokracuji
            return rozhodnuti;
        }
        //2.2 soucet stredni vaha+
        if (skoreCelkem >= m_vahy.stredni)
        {
            int bestIndex= 0;
            int bestSkore= 0;

            if (m_nalezeneKombinace.size()==1)
            {
                analyzujStat(m_nalezeneKombinace[0].kostkyKombinace.size(), pocetOdlozenych, skoreKolo);
                if (m_vahy.ptsStredni < zpoctiPtsUspechu()*100)
                    rozhodnuti.hratDal= true;
                else
                    rozhodnuti.hratDal= false;
                rozhodnuti.indexKomb= 0;
                return rozhodnuti;
            }

            for (int i=0; i<m_nalezeneKombinace.size(); i++)
            {
                analyzujStat(m_nalezeneKombinace[i].kostkyKombinace.size(), pocetOdlozenych, skoreKolo);
                //std::cout<<"pts 350+ 600+ : "<<zpoctiPtsUspechu()*100<<std::endl;
                if (m_vahy.stredni < zpoctiPtsUspechu()*100)
                {
                    if ((skoreCelkem)-(skoreKolo+m_nalezeneKombinace[i].body)<=300)
                    {
                        if (m_nalezeneKombinace[i].body > bestSkore)
                        {
                            bestIndex= i;
                            bestSkore= m_nalezeneKombinace[i].body;
                        }
                    }
                }
            }

            if (bestSkore > 0)
            {
                rozhodnuti.hratDal= true;
                rozhodnuti.indexKomb= bestIndex;
                return rozhodnuti;
            }
            rozhodnuti.hratDal= false;
            rozhodnuti.indexKomb= 1000;  //kod zapis vse, false nepokracuji
            return rozhodnuti;
        }
        //2.3 soucet stredni vaha-
        if (skoreCelkem < m_vahy.stredni)
        {
            int bestIndex= 0;
            int bestSkore= 0;

            if (m_nalezeneKombinace.size()==1)
            {
                analyzujStat(m_nalezeneKombinace[0].kostkyKombinace.size(), pocetOdlozenych, skoreKolo);
                if (m_vahy.ptsDolni < zpoctiPtsUspechu()*100)
                    rozhodnuti.hratDal= true;
                else
                    rozhodnuti.hratDal= false;
                rozhodnuti.indexKomb= 0;
                return rozhodnuti;
            }

            for (int i=0; i<m_nalezeneKombinace.size(); i++)
            {
                analyzujStat(m_nalezeneKombinace[i].kostkyKombinace.size(), pocetOdlozenych, skoreKolo);
                if (m_vahy.ptsDolni < zpoctiPtsUspechu()*100)
                {
                    if ((m_nalezeneKombinace[i].kostkyKombinace.size()==3) && (m_nalezeneKombinace[i].body >= 400))
                    {
                        rozhodnuti.hratDal= true;
                        rozhodnuti.indexKomb= i;
                        return rozhodnuti;
                    }
                    if ((skoreCelkem)-(m_nalezeneKombinace[i].body)<=300)
                    {
                        if ((m_nalezeneKombinace[i].body >= 50) && (m_nalezeneKombinace[i].body <= 100))
                        {
                            if (m_nalezeneKombinace[i].body > bestSkore)
                            {
                                bestIndex= i;
                                bestSkore= m_nalezeneKombinace[i].body;
                            }
                        }
                    }
                }
            }

            if (bestSkore > 0)
            {
                rozhodnuti.hratDal= true;
                rozhodnuti.indexKomb= bestIndex;
                return rozhodnuti;
            }
            rozhodnuti.hratDal= false;
            rozhodnuti.indexKomb= 1000;  //kod zapis vse, false nepokracuji
            return rozhodnuti;
        }
    }







}

